/* =========================================================================================================
  Script Revive ADO : revive_respawn.sqf
  Version: 1.31
  Auteur: The-KiLLeR (www.clan-ado.fr / killouze@hotmail.fr)
========================================================================================================= */
// Informations sur le cadavre
private ["_cadavre","_pos","_joueur","_dialog"];
_cadavre = player;
_pos = getPosATL player;
_dir = getDir player;

cutText ["", "BLACK"];

// Attente de la réapparition du joueur
waitUntil { alive player };
_joueur = player;

// Si le joueur n'a plus de vie
if (ADO_REVIVE_nb_vies == 0) exitWith {

	private ["_corps","_croix","_camera"];

	ADO_REVIVE_morts = ADO_REVIVE_morts + [_joueur];
	publicVariable "ADO_REVIVE_morts";
	
	deleteVehicle _cadavre;
	_joueur setPos (getMarkerPos "ado_revive_zone_morts");
	sleep 0.5;
	_corps = "Grave" createVehicle _pos;
	_croix = "GraveCross1" createVehicle _pos;
	_corps setDir _dir;
	_croix attachTo [_corps,[0,0.9,0.3]];
	
	// Caméra sur la tombe
	_camera = "camera" camCreate (getPos _corps);
	_camera camSetTarget _corps;
	_camera cameraEffect ["internal","FRONT"];
	_camera camCommit 0;
	_camera attachTo [_corps, [0,-2.5,1]];
	cutText ["", "PLAIN"];
	
	player groupChat "Vous êtes mort";
};

// Si le joueur était dans l'eau
if (surfaceIsWater _pos) exitWith {

	for [{_x = ADO_REVIVE_temps_eau},{_x > 0},{_x = _x - 1}] do {

		titleText [format["Temps restant : %1s",_x], "PLAIN"];
		sleep 1;
	};
	titleText ["Réapparition en cours..", "PLAIN"];
	sleep 1;
	titleText ["", "PLAIN"];
	cutText ["", "PLAIN"];
	
	// On enlève 1 vie au joueur
	ADO_REVIVE_nb_vies = ADO_REVIVE_nb_vies - 1;
	
	hint format["Vies restantes : %1",ADO_REVIVE_nb_vies];
};

// Animation blessé
_joueur switchMove "AinjPpneMstpSnonWrflDnon";
_joueur setDamage 0.8;

// Actions sur le joueur
call compile format ["%1 setVehicleInit '%1 = this; %1_action_reanimer = this addAction [''Réanimer'',''ADO_revive\revive_actions.sqf'',1,1,false,true,'''',''(animationState %1 == ''''AinjPpneMstpSnonWrflDnon'''' || getDammage %1 == 0.8) && (getDammage %1 < 0.65 || getDammage %1 > 0.75)'']; %1_action_trainer = this addAction [''Trainer le corps'',''ADO_revive\revive_actions.sqf'',2,1,false,true,'''',''(animationState %1 != ''''ainjppnemstpsnonwrfldb_still'''' || getDammage %1 == 0.8) && (getDammage %1 < 0.65 || getDammage %1 > 0.75)'']; %1_action_lacher = this addAction [''Lacher le corps'',''ADO_revive\revive_actions.sqf'',3,1,false,true,'''',''animationState %1 == ''''ainjppnemstpsnonwrfldb_still'''' || getDammage %1 == 0.6'']; this allowDamage false; this setCaptive true;'",_joueur];
processInitCommands;

call compile format["%1 removeAction %1_action_reanimer; %1 removeAction %1_action_trainer; %1 removeAction %1_action_lacher;",_joueur];
processInitCommands;

sleep 2;
deleteVehicle _cadavre;
sleep 0.1;
_joueur setPos _pos;
_joueur setDir _dir;

cutText ["", "PLAIN"];

// Affichage du bouton "Réapparition"
if (ADO_REVIVE_zone || ADO_REVIVE_mobile_respawn) then {
	_dialog = createDialog "ADO_REVIVE_dialog";
	ctrlEnable [68330, false];
	ctrlEnable [68340, false];
	ctrlEnable [68350, false];

	if (!ADO_REVIVE_zone) then {
		ctrlShow [68330, false];
	};	
	if (!ADO_REVIVE_mobile_respawn) then {
		ctrlShow [68340, false];
		ctrlShow [68350, false];
	} else {
		if (ADO_REVIVE_nb_mobile_respawn == 1) then {
			ctrlShow [68350, false];
		};
	};
	
	[] spawn
	{
		for [{_i = ADO_REVIVE_temps_bp},{_i > 0},{_i = _i - 1}] do {
		
			if (getDammage player == 0.5 || !alive player) exitWith {};
		
			hintsilent format["Temps restants : %1s",_i];
			sleep 1;
		};
		hintsilent format["",_i];
		
		if (getDammage player == 0.5 || !alive player) exitWith {
			closeDialog 0;
		};
		
		ctrlEnable [68330, true];
		ctrlEnable [68340, true];
		ctrlEnable [68350, true];
		ADO_REVIVE_bp2 = true;
	};
};

player groupChat "Vous êtes en attente de réanimation";

// En attente de réanimation
while {getDammage _joueur != 0.5} do {

	if (getDammage _joueur == 0.5 || !alive player || ADO_REVIVE_bp || ADO_REVIVE_bp_respawn1 || ADO_REVIVE_bp_respawn2) exitWith {};

	if ((ADO_REVIVE_zone || ADO_REVIVE_mobile_respawn) && isNull(findDisplay 68300)) then {
		_dialog = createDialog "ADO_REVIVE_dialog";
		ctrlEnable [68330, false];
		ctrlEnable [68340, false];
		ctrlEnable [68350, false];
		
		if (!ADO_REVIVE_zone) then {
			ctrlShow [68330, false];
		};	
		if (!ADO_REVIVE_mobile_respawn) then {
			ctrlShow [68340, false];
			ctrlShow [68350, false];
		} else {
			if (ADO_REVIVE_nb_mobile_respawn == 1) then {
				ctrlShow [68350, false];
			};
		};
		
		if (ADO_REVIVE_bp2) then {
			ctrlEnable [68330, true];
			ctrlEnable [68340, true];
			ctrlEnable [68350, true];
		};
	};
	
	if (getDammage _joueur == 0.6) then {
		if (animationState _joueur != "ainjppnemstpsnonwrfldb_still") then {
			_joueur switchMove "ainjppnemstpsnonwrfldb_still";
		};
		ctrlEnable [68330, false];
		ctrlEnable [68340, false];
		ctrlEnable [68350, false];	
	} else {
		if (animationState _joueur != "AinjPpneMstpSnonWrflDnon") then {
			_joueur playMove "AinjPpneMstpSnonWrflDnon";	
		};
		if (ADO_REVIVE_bp2) then {
			ctrlEnable [68330, true];
			ctrlEnable [68340, true];
			ctrlEnable [68350, true];
		};
	};
	
	if (getDammage _joueur == 0.7) then {
		ctrlEnable [68330, false];
		ctrlEnable [68340, false];
		ctrlEnable [68350, false];
	};
	
	if (ADO_REVIVE_mobile_respawn && !alive ado_mobile_respawn_1) then {ctrlEnable [68340, false];};
	if (ADO_REVIVE_mobile_respawn && !alive ado_mobile_respawn_2) then {ctrlEnable [68350, false];};
	
	sleep 1;
};

if (!alive player) exitWith {
	closeDialog 0;
	ADO_REVIVE_bp = false;
	ADO_REVIVE_bp2 = false;
	ADO_REVIVE_bp_respawn1 = false;
	ADO_REVIVE_bp_respawn2 = false;
};

call compile format["%1 setVehicleInit '%1 = this; this removeAction %1_action_reanimer; this removeAction %1_action_trainer; this removeAction %1_action_lacher; this allowDamage true; this setCaptive false; this setDamage 0.5;'",_joueur];
processInitCommands;

// Si réapparition au mobile respawn
if (ADO_REVIVE_bp_respawn1 || ADO_REVIVE_bp_respawn2) then {
	
	private ["_posMobile","_dirMobile"];

	// On enlève 1 vie au joueur
	ADO_REVIVE_nb_vies = ADO_REVIVE_nb_vies - 1;
	
	_joueur switchMove "";
	
	if (ADO_REVIVE_bp_respawn1) then {
		_posMobile = getPos ado_mobile_respawn_1;
		_dirMobile = getDir ado_mobile_respawn_1;
		player groupChat "Vous avez réapparu au mobile respawn 1";
	};
	if (ADO_REVIVE_bp_respawn2) then {
		_posMobile = getPos ado_mobile_respawn_2;
		_dirMobile = getDir ado_mobile_respawn_2;
		player groupChat "Vous avez réapparu au mobile respawn 2";
	};
	_joueur setPos [(_posMobile select 0)+(-5*sin _dirMobile), (_posMobile select 1)+(-5*cos _dirMobile), 0];
	hint format["Vies restantes : %1",ADO_REVIVE_nb_vies];
};

// Si réapparition à la base
if (ADO_REVIVE_bp) then {

	private ["_zone"];

	// On enlève 1 vie au joueur
	ADO_REVIVE_nb_vies = ADO_REVIVE_nb_vies - 1;
	
	_joueur switchMove "";
	
	call compile format["%1 setVehicleInit '%1 = this; this setDamage 0;'",_joueur];
	processInitCommands;
	
	_zone = switch (side _joueur) do {
		case WEST: {ADO_REVIVE_zone_ouest};
		case EAST: {ADO_REVIVE_zone_est};
		case RESISTANCE: {ADO_REVIVE_zone_independant};
		case CIV: {ADO_REVIVE_zone_civil};
	};
	_joueur setPos (getMarkerPos _zone);
	player groupChat "Vous avez réapparu à la base";
	hint format["Vies restantes : %1",ADO_REVIVE_nb_vies];
};

// Si réapparition sur place
if (!ADO_REVIVE_bp && !ADO_REVIVE_bp_respawn1 && !ADO_REVIVE_bp_respawn2) then {
	_joueur playMove "amovppnemstpsraswrfldnon";
	
	if (!ADO_REVIVE_reanimer_vie) then {
		// On enlève 1 vie au joueur
		ADO_REVIVE_nb_vies = ADO_REVIVE_nb_vies - 1;
		sleep 1;
		hint format["Vies restantes : %1",ADO_REVIVE_nb_vies];
	};
};

closeDialog 0;
ADO_REVIVE_bp = false;
ADO_REVIVE_bp2 = false;
ADO_REVIVE_bp_respawn1 = false;
ADO_REVIVE_bp_respawn2 = false;

if (true) exitWith {};